﻿import datetime,socket,subprocess,os
import xbmc,xbmcplugin,xbmcgui,xbmcaddon,xbmcvfs
import httplib
import sys

__addon__ = xbmcaddon.Addon()
__addon_id__ = __addon__.getAddonInfo('id')
__addonpath__ = xbmc.translatePath(__addon__.getAddonInfo('path'))
__path_img__ = __addonpath__ + '/images/'


# -- Constants ----------------------------------------------
ADDON_ID = 'script.ips.light'

# -- Settings -----------------------------------------------
settings = xbmcaddon.Addon(id=ADDON_ID)

# -- I18n ---------------------------------------------------
language = xbmcaddon.Addon(id=ADDON_ID).getLocalizedString
ACTION_MOVE_LEFT = 1
ACTION_MOVE_RIGHT = 2
ACTION_MOVE_UP = 3
ACTION_MOVE_DOWN = 4
ACTION_PARENT_DIR = 92

ACTION_PREVIOUS_MENU = 10
ACTION_SELECT_ITEM = 7
 
class MyClass(xbmcgui.WindowDialog):
  def __init__(self):
    # set background
    self.bg = xbmcgui.ControlImage(0, 0, 570, 340, __path_img__ + 'bg.png')
    self.addControl(self.bg)
    
    self.strActionInfo = xbmcgui.ControlLabel(200, 10, 200, 30, '', 'font13')
    self.addControl(self.strActionInfo)
    self.strActionInfo.setLabel('IPS Light Manager')
    
# Button 1    
    self.button1 = xbmcgui.ControlLabel(20, 80, 200, 30, '', 'font13')
    self.addControl(self.button1)
    self.button1.setLabel(settings.getSetting('button1'))

    self.button1on = xbmcgui.ControlButton(250, 80, 60, 30, "Ein")
    self.addControl(self.button1on)
    self.button1off = xbmcgui.ControlButton(310, 80, 60, 30, "Aus")
    self.addControl(self.button1off)

    self.slider1 = xbmcgui.ControlSlider(380, 80, 150, 25)
    self.addControl(self.slider1)
    self.slider1.setPercent(50)
    
# Button 2
    self.button2 = xbmcgui.ControlLabel(20, 120, 200, 30, '', 'font13')
    self.addControl(self.button2)
    self.button2.setLabel(settings.getSetting('button2'))

    self.button2on = xbmcgui.ControlButton(250, 120, 60, 30, "Ein")
    self.addControl(self.button2on)
    self.button2off = xbmcgui.ControlButton(310, 120, 60, 30, "Aus")
    self.addControl(self.button2off)

    self.slider2 = xbmcgui.ControlSlider(380, 120, 150, 25)
    self.addControl(self.slider2)
    self.slider2.setPercent(50)
# Button 3
    self.button3 = xbmcgui.ControlLabel(20, 160, 200, 30, '', 'font13')
    self.addControl(self.button3)
    self.button3.setLabel(settings.getSetting('button3'))

    self.button3on = xbmcgui.ControlButton(250, 160, 60, 30, "Ein")
    self.addControl(self.button3on)
    self.button3off = xbmcgui.ControlButton(310, 160, 60, 30, "Aus")
    self.addControl(self.button3off)

    self.slider3 = xbmcgui.ControlSlider(380, 160, 150, 25)
    self.addControl(self.slider3)
    self.slider3.setPercent(50)
# Button 4
    self.button4 = xbmcgui.ControlLabel(20, 200, 200, 30, '', 'font13')
    self.addControl(self.button4)
    self.button4.setLabel(settings.getSetting('button4'))

    self.button4on = xbmcgui.ControlButton(250, 200, 60, 30, "Ein")
    self.addControl(self.button4on)
    self.button4off = xbmcgui.ControlButton(310, 200, 60, 30, "Aus")
    self.addControl(self.button4off)

    self.slider4 = xbmcgui.ControlSlider(380, 200, 150, 25)
    self.addControl(self.slider4)
    self.slider4.setPercent(50)
# Button 5
    self.button5 = xbmcgui.ControlLabel(20, 240, 200, 30, '', 'font13')
    self.addControl(self.button5)
    self.button5.setLabel(settings.getSetting('button5'))

    self.button5on = xbmcgui.ControlButton(250, 240, 60, 30, "Ein")
    self.addControl(self.button5on)
    self.button5off = xbmcgui.ControlButton(310, 240, 60, 30, "Aus")
    self.addControl(self.button5off)

    self.slider5 = xbmcgui.ControlSlider(380, 240, 150, 25)
    self.addControl(self.slider5)
    self.slider5.setPercent(50)
# Button EXIT
    self.buttonExit = xbmcgui.ControlButton(20, 280, 350, 30, "EXIT")
    self.addControl(self.buttonExit)

# Navigation    
    self.setFocus(self.button1on)
    self.button1on.controlDown(self.button2on)
    self.button2on.controlDown(self.button3on)
    self.button3on.controlDown(self.button4on)
    self.button4on.controlDown(self.button5on)
    self.button5on.controlDown(self.buttonExit)
    self.buttonExit.controlDown(self.button1on)
    self.slider1.controlDown(self.button1off)
    self.slider2.controlDown(self.button2off)
    self.slider3.controlDown(self.button3off)
    self.slider4.controlDown(self.button4off)
    self.slider5.controlDown(self.button5off)
    
    self.button1on.controlUp(self.buttonExit)
    self.button2on.controlUp(self.button1on)
    self.button3on.controlUp(self.button2on)
    self.button4on.controlUp(self.button3on)
    self.button5on.controlUp(self.button4on)
    self.buttonExit.controlUp(self.button5on)
    self.slider1.controlUp(self.button1off)
    self.slider2.controlUp(self.button2off)
    self.slider3.controlUp(self.button3off)
    self.slider4.controlUp(self.button4off)
    self.slider5.controlUp(self.button5off)

    self.button1on.controlRight(self.button1off)
    self.button2on.controlRight(self.button2off)
    self.button3on.controlRight(self.button3off)
    self.button4on.controlRight(self.button4off)
    self.button5on.controlRight(self.button5off)
    self.button1off.controlRight(self.slider1)
    
    self.button2off.controlRight(self.slider2)
    self.button3off.controlRight(self.slider3)
    self.button4off.controlRight(self.slider4)
    self.button5off.controlRight(self.slider5)
    
    self.button1off.controlLeft(self.button1on)
    self.button2off.controlLeft(self.button2on)
    self.button3off.controlLeft(self.button3on)
    self.button4off.controlLeft(self.button4on)
    self.button5off.controlLeft(self.button5on)
    
    self.button1off.controlDown(self.button2off)
    self.button2off.controlDown(self.button3off)
    self.button3off.controlDown(self.button4off)
    self.button4off.controlDown(self.button5off)
    self.button5off.controlDown(self.buttonExit)

    self.button1off.controlUp(self.buttonExit)    
    self.button2off.controlUp(self.button1off)
    self.button3off.controlUp(self.button2off)
    self.button4off.controlUp(self.button3off)
    self.button5off.controlUp(self.button4off)

 
  def onAction(self, action):
    if action == ACTION_PARENT_DIR:
      self.close()
    if action == ACTION_PREVIOUS_MENU:
      self.close()
    if action == ACTION_SELECT_ITEM:
      if self.slider1 == self.getFocus():
        wert = "{:.0f}".format((self.slider1.getPercent()))
        self.SendCommand('slider1',wert)        
      if self.slider2 == self.getFocus():
        wert = "{:.0f}".format((self.slider2.getPercent()))
        self.SendCommand('slider2',wert)        
      if self.slider3 == self.getFocus():
        wert = "{:.0f}".format((self.slider3.getPercent()))
        self.SendCommand('slider3',wert)        
      if self.slider4 == self.getFocus():
        wert = "{:.0f}".format((self.slider4.getPercent()))
        self.SendCommand('slider4',wert)        
      if self.slider5 == self.getFocus():
        wert = "{:.0f}".format((self.slider5.getPercent()))
        self.SendCommand('slider5',wert)        
        
  
  def onControl(self, control):
    if control == self.button1on:
      self.SendCommand('button1on','')
    if control == self.button1off:
      self.SendCommand('button1off','')
    if control == self.button2on:
      self.SendCommand('button2on','')
    if control == self.button2off:
      self.SendCommand('button2off','')
    if control == self.button3on:
      self.SendCommand('button3on','')
    if control == self.button3off:
      self.SendCommand('button3off','')
    if control == self.button4on:
      self.SendCommand('button4on','')
    if control == self.button4off:
      self.SendCommand('button4off','')
    if control == self.button5on:
      self.SendCommand('button5on','')
    if control == self.button5off:
      self.SendCommand('button5off','')
    if control == self.buttonExit:
      self.close()

  def getCommand(self,command):
	return settings.getSetting(command)

  def SendCommand(self,command,wert):
    xbmc.log ('Sending command to IP-Symcon: '+command)
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.settimeout(1)   # 5 seconds
    s.connect((settings.getSetting('hostname'), int(settings.getSetting('port'))))
    s.send((settings.getSetting('kodiid'))+'-{0}'.format(self.getCommand(command))+wert)
    s.close()


    
mydisplay = MyClass()
mydisplay .doModal()
del mydisplay
